
var debug = true;
var file = Components.classes["@mozilla.org/file/directory_service;1"].
           getService(Components.interfaces.nsIProperties).
           get("CurProcD", Components.interfaces.nsIFile);
if (file.exists('content')) {
	jndump("DEBUGGING MODE - Text-dumps are enabled...\n");
} else {
	debug = false;
}

var VERSION = 0.3;

var contextMenuElements = ["INPUT", "TEXTAREA"];

var tine20config = {
	baseUrl: "",
	username: "",
	password: "",
	closingpage: "about:blank",
	version: 0
}

var prefs = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService).getBranch("tinepurse.");
var passwordManager = Components.classes["@mozilla.org/login-manager;1"]
	.getService(Components.interfaces.nsILoginManager);
var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
	Components.interfaces.nsILoginInfo, "init");

function init_purse() {
	var logins = passwordManager.findLogins({}, 'tinepurse://default', null, 'Tine 2.0 Login');
	for (i in logins) {
		tine20config.username = logins[i].username;
		tine20config.password = logins[i].password;
	}
	tine20config.baseUrl = tineUrl(
		prefs.prefHasUserValue("useSSL")? prefs.getBoolPref("useSSL") : false,
		prefs.prefHasUserValue("host")? prefs.getCharPref("host") : '',
		prefs.prefHasUserValue("dir")? prefs.getCharPref("dir") : ''
	); 
	tine20config.version = prefs.prefHasUserValue("version")? prefs.getCharPref("version") : 0;
}

/*
 * Execute link on external browser
 */

if (typeof process == undefined) {
	var osString = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULRuntime).OS;
	// Returns "WINNT" on Windows Vista, XP, 2000, and NT systems;
	// "Linux" on GNU/Linux; and "Darwin" on Mac OS X.
	var starterApp = null;
	if (osString == 'Linux')
		starterApp = '/usr/bin/xdg-open';
	if (osString == 'WINNT')
		startsr = 'start.exe';
	var file = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	var process = Components.classes["@mozilla.org/process/util;1"]
		.getService(Components.interfaces.nsIProcess);
	file.initWithPath(starterApp);
	process.init(file);
}

function pass_browser(link) {
	process.run(false, [link], 1);
}

/*
 * Helpers
 */

function jndump(txt) {
	// kind 'a debug
	if (debug == true) {
		dump(txt);
	}
}

function tineUrl(ssl, host, dir) {
	if (ssl) {
		var url = 'https://'
	} else {
		var url = 'http://'
	}
	if (host == '') {
		return '';
	}
	url = url +  host;
	if (dir.substr(0, 1) != '/') {
		dir = '/' + dir;
	}
	if (dir.substr(dir.length-1, 1) != '/' && dir.substr(dir.length-9, 9) != 'index.php') {
		dir = dir + '/';
	}
	url = url + dir;
	return url;
}

function tineRequest(url, obj, jsonKey = 'undefined') { 
	var req = new XMLHttpRequest();
	req.open('POST', url, false);
	var post = JSON.stringify(obj); 
	req.setRequestHeader('X-Tine20-Request-Type','JSON');
	req.setRequestHeader('X-Tine20-JsonKey', jsonKey);
	req.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');
	req.setRequestHeader("Content-Length", post.length);
	req.setRequestHeader("Connection", 'close');
	try {
		req.send(post);
	} catch(e) {
		jndump('Tine-Request: ' + e.message + "!\n");
		return false;
	}
	
	var json = null;
	if (req.status == 200 && req.getResponseHeader('Content-Type') == 'application/json') { 
		json = JSON.parse(req.responseText)[0];
		jndump("Tine20-Request: success\n");
	}
	if (json != null && typeof json.result != 'undefined' && json.result.success == true) {
		return json.result; 
	} else {
		return false; // json.error or json.result.success == false
	}
}

/*
 * Mozilla prompts
 */

var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                              .getService(Components.interfaces.nsIPromptService);

function alertDlg(title, text) {
	promptService.alert(null, title, text);
}

function confirmDlg(title, text) {
	return promptService.confirm(null, title, text);
}

function yesNoDlg(title, text) {
	var yn = promptService.confirmEx(null, title, text, 
		promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + 
		promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1, 
	"Yes", "No", null, null, {});
	if (yn === 0)
		return true;
	else
		return false;
}

function selectDlg(title, text, items_array) {
	var selected = {};
	if (promptService.select(null, title, text, items_array.length, items_array, selected)) {
		return selected;
	} else {
		return false;
	}
}

var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
	.getService(Components.interfaces.nsIAlertsService);

function notifyAlert(title, text) {
	alertsService.showAlertNotification(
		"chrome://tinepurse/content/skin/icons/tine_logo.png", 
		title,
		text,
		false, "", null, "Tine 2.0 purse"
	);
}
