
var tine20 = {
	
	logout: function(closeWindow) {
		var browser = document.getElementById("browser"); 
		// do not logout if popup menu is selected -> state=hiding
		if (closeWindow == false) {
			browser.messageManager.sendAsyncMessage("logout", {'configure': 'true'});
		}
		if (document.getElementById('LogOutButtonMenu').state == 'hiding') {
			return false;
		}
		// ask before closing editing windows - TODO
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
        var open_windows = windowMediator.getXULWindowEnumerator('editor');
        if (open_windows.hasMoreElements()) {
			if (!confirmDlg(strings.quit, strings.openWindowsQuestion)) {
				return false;
			}
		}
		// "clicking" logout
		browser.messageManager.sendAsyncMessage("logout", {});
	},
	
	reload: function() {
		var browser = document.getElementById("browser");
		browser.reload();
		return false;
	},
	
	conf: function() {
		if (tine20.loggedIn == true)
			this.logout(false);
		else (tine20.loggedIn == null)
			window.openDialog("chrome://tinepurse/content/configWindow.xul ", "Configuration", "dialog,toolbar,modal", null);
		// window opener is in onload() -> listener("configure")
	},
	
	showDownloads: function() {
		try {
		  window.openDialog("chrome://mozapps/content/downloads/downloads.xul ", "Downloads", "dialog=false", null);
		} catch(e) {}
	},
	
	activateTab: function(app) { 
		var browser = document.getElementById("browser");
		if (app == 'LogOut')
			browser.messageManager.sendAsyncMessage("logout", {});
		else
			browser.messageManager.sendAsyncMessage("activateTab", {app: app});
		jndump("Activate app " + app + "...\n");
	},
	
	doAction: function(app, arg) { 
		var browser = document.getElementById("browser"); 
		if (arg === true) {
			browser.messageManager.sendAsyncMessage("simulateButton", {app: app, fields: false});
			jndump("Open (empty) editor for " + app + "...\n");
		} else {
			var fields = {}; 
			// open window with special content
			if (app == 'Felamimail') { 
				fields = inputHelper.parseMailto(arg);
				if (fields.body) {
					fields.body = fields.body.replace(/\r\n/g, "\n");
					fields.body = fields.body.replace(/\n/g, "<br>");
				}
			} else if (app == 'Addressbook') {
				var vc_obj = {}; 
				inputHelper.parseVCard( inputHelper.readTextFile(arg), vc_obj );
				var i_parts = [], unnamed_elements = [], bday = null;
				for (i in vc_obj) { 
					// complex structures
					if (typeof vc_obj[i] == 'object') {
						for (a in vc_obj[i]) { 
							// tel:{'type=work':Array(phone, mobile, fax), ...}
							if (i == 'tel' && a == 'type=home') { 
								unnamed_elements = Array('_home', '_cell_private', '_fax_home', '_prefer');
								for (e = 0; e < vc_obj[i][a].length; e++) { 
									fields['tel' + unnamed_elements[e]] = vc_obj[i][a][e];
								}
							}
							else if (i == 'tel') {
								unnamed_elements = Array('_work', '_cell', '_fax', '_assistent', '_car', '_pager', '_other');
								for (e = 0; e < vc_obj[i][a].length; e++) { 
									fields['tel' + unnamed_elements[e]] = vc_obj[i][a][e];
								}
							}
							// email
							else if (i == 'email') {
								fields['email' + (a == 'type=home' ? '_home' : '')] = vc_obj[i][a][0];
							}
							// adr:{'type=work':Array(Array()), ...}
							else if (i == 'adr') {
								unnamed_elements = Array('', '_street2', '_street', '_locality', '_region', '_postalcode', '_countryname');
								for (e = 1; e < vc_obj[i][a][0].length; e++) {
									fields['adr' + (a == 'type=home' ? '_two' : '_one') + unnamed_elements[e]] = vc_obj[i][a][0][e];
								}
							}
							// url
							else if (i == 'url') {
								fields['url' + (a == 'type=home' ? '_home' : '')] = vc_obj[i][a][0];
							}
							// birthday
							else if (i == 'bday') {
								if (a == 'value=date-time') {
									bday = Date.parse(vc_obj[i][a][0].substr(0, 4) + '/' + vc_obj[i][a][0].substr(4, 2) + '/' + vc_obj[i][a][0].substr(6, 2) + ' ' + vc_obj[i][a][0].substr(9, 2) + ':' + vc_obj[i][a][0].substr(11, 2) + ':' + vc_obj[i][a][0].substr(13, 2));
									bday = bday - (new Date().getTimezoneOffset() * 60000);
									bday = new Date(bday);
									fields['bday'] = bday.getFullYear() + '-' + (bday.getMonth() < 9 ? '0' : '') + (bday.getMonth()+1) + '-' + (bday.getMonth() < 10 ? '0' : '') + bday.getDate() + ' 00:00:00';
								}
							}
							// jpegphoto
							else if (i == 'photo') {
								if (a == 'type=jpeg') {
									fields['image'] = 'data:image/jpeg;base64,' + vc_obj[i][a];
								}
							}
							// unknown object
							else {
								jndump("Unknown Object '" + JSON.stringify(i) + "' found when parsing vCard...\n");
							}
						}
					// simple structures
					} else {
						i_parts = vc_obj[i].split(';');
						if (i == 'version' || i == 'fn') {
							// ignore
						}
						else if (i == 'org') { 
							fields['org_name'] = i_parts[0];
							fields['org_unit'] = i_parts[1];
						}
						else if (i == 'n') { 
							fields['n_family'] = i_parts[0];
							fields['n_given'] = i_parts[1];
						}
						else {
							fields[i] = vc_obj[i];
						}
					}
				}
			} else if (app == 'Calendar') { 
				var ics_obj = []; 
				inputHelper.parseICAL( inputHelper.readTextFile(arg), ics_obj ); 
				var i = 0;
				// make sure that user doesn't open nore than one window
				if (ics_obj.length > 1) {
					var items = [];
					for (i in ics_obj) {
						items.push(ics_obj[i]['summary']);
					}
					i = selectDlg(strings.calendarMultipleTitle, strings.calendarMultipleText.replace(/XXX/g, items.length), items);
					if (i == false) {
						return false;
					}
					i = i.value;
				}
				// enumerate entries
				fields.summary = ics_obj[i].summary;
				fields.description = ics_obj[i].description;
				fields.dtstart = ics_obj[i].start_date + ' ' + ics_obj[i].start_time + ':00';
				fields.dtend = ics_obj[i].end_date + ' ' + ics_obj[i].end_time + ':00';
				for (a in ics_obj[i]) {
					if (a.substr(0, 9) == 'organizer') {
						fields.organizer = a.split(';')[1].split('=')[1] + ' <' + ics_obj[i][a].split(':')[1] + '>';
					}
				}
			} else if (app == 'Tasks') {
				
			}
			browser.messageManager.sendAsyncMessage("simulateButton", {app: app, fields: fields});
			jndump("Open editor (with data) for " + app + "...\n");
		}
	},
	
	listener: null,
	
	loggedIn: null,

	onload: function() { 
		
	  if (this.listener != null) {
		return true;  
	  }
	  
	  init_purse(this);

	  var browser = document.getElementById("browser");
	  
	  // initialize homepage
	  if (browser.contentWindow.location == 'chrome://tinepurse/content/homepage.html') {
		browser.contentDocument.getElementById("LoginSlogan").textContent = strings.welcomeSlogan;
	  }

	  // new version of purse
	  var config_version 
	  if (VERSION > tine20config.version) {
		window.openDialog("chrome://tinepurse/content/configWindow.xul ", "Configuration", "dialog,toolbar,modal", 'newVersion');
		return false;
	  }
	  
	  // catch calls before forbidden sites are loaded ~ "sandbox"
	  this.listener = new WebProgressListener();
	  browser.addProgressListener(this.listener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
	  
	  // receive empty document => terminate
	  browser.messageManager.addMessageListener("quit", function(m) {
		/*
		 * Clean up profile directory would be nice ~ 10MB useless data will get to roaming otherwise
		 */ 
	    var appStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"]
		    .getService(Components.interfaces.nsIAppStartup);
		appStartup.quit(Components.interfaces.nsIAppStartup.eForceQuit);
	  });
	  // receive debug message
	  browser.messageManager.addMessageListener("debug", function(m) { 
		  jndump(eval(m.json.message));
	  });
	  // log user in
	  browser.messageManager.addMessageListener("login_success", function(m) {
	    tine20.loggedIn = true;
	    // when logged in successfully send initial cli parameters
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
										 .getService(Components.interfaces.nsIObserverService);
		observerService.notifyObservers(window.arguments[0], "purse-instance-cli", null);
		jndump("Logged in...\n");
	  });
	  // login failed, need to configure?
	  browser.messageManager.addMessageListener("configure", function(m) { 
		if(m.json.dialog == tine20config.closingpage+'?configure' || yesNoDlg(strings.loginFailedTitle, strings.loginFailedText)) {
			window.openDialog("chrome://tinepurse/content/configWindow.xul ", "Configuration", "dialog,toolbar,modal", null);
		}
		else
			tine20.logout();
	  });
	  // notify text
	  browser.messageManager.addMessageListener("notify", function(m) {
		/*var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
			.getService(Components.interfaces.nsIAlertsService);
		alertsService.showAlertNotification(
			"chrome://tinepurse/content/skin/icons/tine_logo.png", 
			m.json.title,
			m.json.text,
			false, "", null, "Tine 2.0 purse"
		);*/
		notifyAlert(m.json.title, m.json.text);
	  });
	  
	  browser.messageManager.loadFrameScript("chrome://tinepurse/content/tine20remote.js", true);

	  if (tine20config.baseUrl == '') {
		  // if no config-data is saved, profile is probably new
		  window.openDialog("chrome://tinepurse/content/configWindow.xul ", "Configuration", "dialog,toolbar,modal", null);
	  } else {
		browser.messageManager.sendAsyncMessage("login", {
			username: tine20config.username, 
			password: tine20config.password, 
			baseUrl: tine20config.baseUrl,
			closingpage: tine20config.closingpage
		});
	  }
	  
	},
	
	onclose: function() {
		this.logout();
	}

}

/*
 * Main window events
 */
 
addEventListener("close", function(event) {
	// Logout before closing window
	tine20.onclose(event);
	observer.unregister;
	event.preventDefault();
}, false);

addEventListener("load", tine20.onload, false);

/*
 * Observer fires on cli-handler.js for every instance
 */
 
function CommandLineObserver() {
  this.register();
}
CommandLineObserver.prototype = {
  observe: function(aSubject, aTopic, aData) {
	var cmdLine = aSubject.QueryInterface(Components.interfaces.nsICommandLine);
	var arg = false;
	var app = false;
	// -mail [arg]  
	if (cmdLine.findFlag("mail", false) >= 0) {
		app = 'Felamimail';
		try {
			arg = cmdLine.handleFlagWithParam("mail", false);
		} catch (e) { }
		if (cmdLine.findFlag("compose", false) >= 0) arg = true;
	}
	else if (cmdLine.findFlag("felamimail", false) >= 0) {
		app = 'Felamimail';
		try {
			arg = cmdLine.handleFlagWithParam("felamimail", false);
		} catch (e) { }
		if (cmdLine.findFlag("compose", false) >= 0) arg = true;
	}
	// -contact [file://]
	else if (cmdLine.findFlag("contacts", false) >= 0) {
		app = 'Addressbook';
		try {
			arg = cmdLine.handleFlagWithParam("contacts", false);
		} catch (e) { }
		if (cmdLine.findFlag("compose", false) >= 0) arg = true;
	}
	else if (cmdLine.findFlag("addressbook", false) >= 0) {
		app = 'Addressbook';
		try {
			arg = cmdLine.handleFlagWithParam("addressbook", false);
		} catch (e) { }
		if (cmdLine.findFlag("compose", false) >= 0) arg = true;
	}
	// -calendar [file://]
	else if (cmdLine.findFlag("calendar", false) >= 0) {
		app = 'Calendar';
		try {
			arg = cmdLine.handleFlagWithParam("calendar", false);
		} catch (e) { }
		if (cmdLine.findFlag("compose", false) >= 0) arg = true;
	}
	// -task [file://]
	else if (cmdLine.findFlag("tasks", false) >= 0) {
		app = 'Tasks';
		try {
			arg = cmdLine.handleFlagWithParam("tasks", false);
		} catch (e) { }
		if (cmdLine.findFlag("compose", false) >= 0) arg = true;
	}
	// -logout
	else if (cmdLine.handleFlag("logout", false)) {
		app = 'LogOut';
	}
		
	// handle app parameters
	if (app) {
		jndump("App parameter given: " + arg + "\n");
		if (arg == false) {
			tine20.activateTab(app);
		} else {
			tine20.doAction(app, arg);
		} 
	}
	
	// handle system parameters
	if (cmdLine.findFlag("registerDefault", false) >= 0) {
		alert("registerDefault");
	}
	else if (cmdLine.findFlag("removeIcons", false) >= 0) {
		alert("removeIcons");
	}
	else if (cmdLine.findFlag("showIcons", false) >= 0) {
		alert("removeIcons");
	}
  },
 
  register: function() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                    .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this, "purse-instance-cli", false);
  },
 
  unregister: function() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                    .getService(Components.interfaces.nsIObserverService);
    observerService.removeObserver(this, "purse-instance-cli");
  }
}
var observer = new CommandLineObserver();

jndump("---Purse started\n");

/*
 * HELPERS for input
 */

var inputHelper = {

	// return object {to: [], cc:[], subject: "" etc. }
	parseMailto: function(url) {
		function add(i, txt, obj) {
			if (!obj[i]) obj[i] = [];
			obj[i].push(txt);
		}

		var obj = {};
		if (url.substr(0,7) == 'mailto:') url = url.substr(7);
		alert(url.split('?')[0]);
		var tmp = url.split('?')[0].split(',');
		for (i in tmp)  {
			add('to', decodeURI(tmp[i]), obj);
		}
		tmp = url.split('?')[1].split('&');
		var part = ''
		for (i in tmp)  {
			part = tmp[i].split('=')[0];
			if (part == 'to' || part == 'cc' || part == 'bcc') {
				add(part, decodeURI(tmp[i].split('=')[1]), obj);
			} else {
				obj[part] = decodeURI(tmp[i].split('=')[1]);
			}
		}
		return obj;
	},
	
	/*
	 * This function was mainly released by Mattt Thompson, 2008
	 * Released under the MIT License
	 * https://github.com/mattt/vcard.js
	 * 
	 * JN: Added simple:n and fixed legal line breaks (/\n\s/g).
	 */
	parseVCard: function(_input, fields) {
		var regexps = {
			simple: /^(version|fn|n|title|org)\:(.+)$/i,
			complex: /^([^\:\;]+);([^\:]+)\:(.+)$/,
			key: /item\d{1,2}\./,
			properties: /((type=)?(.+);?)+/
		}
		
		_input = _input.replace(/\r\n/g, "\n");
		_input = _input.replace(/\n\s/g, "");
		var lines = _input.split("\n");
		for (n in lines) {
			line = lines[n];

			if(regexps['simple'].test(line)) {
				results = line.match(regexps['simple']);
				key = results[1].toLowerCase();
				value = results[2];

				fields[key] = value;
			}

			else if(regexps['complex'].test(line)) {
			results = line.match(regexps['complex']);
			key = results[1].replace(regexps['key'], '').toLowerCase();

			properties = results[2].split(';');
			properties = Array.filter(properties, function(p) { return ! p.match(/[a-z]+=[a-z]+/) });
			properties = Array.map(properties, function(p) { return p.replace(/type=/g, '') });

			type = properties.pop() || 'default';
			type = type.toLowerCase();

			value = results[3];
			value = /;/.test(value) ? [value.split(';')] : value;

			fields[key] = fields[key] || {};
			fields[key][type] = fields[key][type] || [];
			fields[key][type] = fields[key][type].concat(value);
			}
		}
	},
	
	/*
	 * This function was mainly released by Carl Saggs, 2012
	 * Released under the MIT License
	 * https://github.com/thybag/
	 * 
	 * JN: put class's function all together, adjust _time and _date
	 */
	parseICAL: function(data, events){
		
		function makeDate (ical_date){
			//break date apart
			var dt = {
				year: ical_date.substr(0,4),
				month: ical_date.substr(4,2),
				day: ical_date.substr(6,2),
				hour: ical_date.substr(9,2),
				minute: ical_date.substr(11,2)
			}
			//Create JS date (months start at 0 in JS - don't ask)
			dt.date = new Date(dt.year, (dt.month-1), dt.day, dt.hour, dt.minute);
			//Get the full name of the given day
			dt.dayname =["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"][dt.date.getDay()];
			return dt;
		}
		
		//Clean string and split the file so we can handle it (line by line)
		//var cal_array = data.replace(new RegExp( "\\r", "g" ), "").split("\n");
		cal_array = data;
		//Keep track of when we are activly parsing an event
		var in_event = false;
		//Use as a holder for the current event being proccessed.
		var cur_event = null;
		for(var i=0;i<cal_array.length;i++){ 
			ln = cal_array[i];
			//If we encounted a new Event, create a blank event object + set in event options.
			if(!in_event && ln == 'BEGIN:VEVENT'){
				in_event = true;
				cur_event = {};
			}
			//If we encounter end event, complete the object and add it to our events array then clear it for reuse.
			if(in_event && ln == 'END:VEVENT'){
				in_event = false;
				events.push(cur_event);
				cur_event = null;
			}
			//If we are in an event
			if(in_event){
				//Split the item based on the first ":"
				idx = ln.indexOf(':');
				//Apply trimming to values to reduce risks of badly formatted ical files.
				type = ln.substr(0,idx).replace(/^\s\s*/, '').replace(/\s\s*$/, '');//Trim
				val = ln.substr(idx+1,ln.length-(idx+1)).replace(/^\s\s*/, '').replace(/\s\s*$/, '');
				
				//If the type is a start date, proccess it and store details
				if(type =='DTSTART'){
					dt = makeDate(val);
					val = dt.date;
					//These are helpful for display
					cur_event.start_time = dt.hour+':'+dt.minute;
					cur_event.start_date = dt.year+'-'+dt.month+'-'+dt.day;
					cur_event.day = dt.dayname;
				}
				//If the type is an end date, do the same as above
				if(type =='DTEND'){
					dt = makeDate(val);
					val = dt.date;
					//These are helpful for display
					cur_event.end_time = dt.hour+':'+dt.minute;
					cur_event.end_date = dt.year+'-'+dt.month+'-'+dt.day;
					cur_event.day = dt.dayname;
				}
				//Convert timestamp
				if(type =='DTSTAMP') val = makeDate(val).date;
				
				//Add the value to our event object.
				cur_event[type.toLowerCase()] = val;
			}
		}
		//Sort the data so its in date order.
		events.sort(function(a,b){
			return a.dtstart-b.dtstart;
		});
	},
	
	readTextFile: function (fileName) {
		var file = Components.classes["@mozilla.org/file/local;1"].
			createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(fileName);
		var data = [];
		var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].
			createInstance(Components.interfaces.nsIFileInputStream);
		fstream.init(file, -1, 0, 0);
		var cstream = fstream.QueryInterface(Components.interfaces.nsILineInputStream);
		var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
			.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		converter.charset = "UTF-8";
		// read in array
		var lineData = {};
		var rawLine;
		while (cstream.readLine(lineData)) {
			// we don't know for sure that input is UTF-8
			try {
				data.push(converter.ConvertToUnicode(lineData.value));
			} catch (e) {
				if (e.name == Components.interfaces.nsIScriptableUnicodeConverter.NS_ERROR_ILLEGAL_INPUT) {
					data.push(converter.ConvertFromUnicode(lineData.value)+converter.Finish());
				}
			} 
		}  
		cstream.close(); 
		return data;
	}
	
};



