
var redirectUrl = 'index.php';

var loggedIn = false;

function debug(txt) {
	sendSyncMessage("debug", {message: JSON.stringify(txt)});
}

addMessageListener("login", function(obj) {
	with (content.wrappedJSObject) {
		document.getElementById('username').value = obj.json.username;
		document.getElementById('password').value = obj.json.password;
		document.getElementById('loginForm').setAttribute('action', obj.json.baseUrl);
		redirectUrl = obj.json.closingpage;
		document.getElementById('loginForm').submit(); 
	}
	if (obj.cli != null) {
		doAfterLogin = obj.json.cli;
	}
});

addMessageListener("logout", function(obj) {
	debug("Log out...\n");
	with (content.wrappedJSObject) {
		// Tine 2.0 is loaded -> log out
		if(typeof document.getElementsByClassName("action_logOut")[0] == 'object') {
			// remove logout confirmation in any case
			Tine.Tinebase.registry.replace('confirmLogout', 0); 
			if (typeof obj.json.configure != 'undefined')
				Tine.Tinebase.registry.replace('redirectUrl', redirectUrl+'?configure');
			else
				Tine.Tinebase.registry.replace('redirectUrl', redirectUrl);
			//document.getElementsByClassName("action_logOut")[0].click();
			Tine.Tinebase.MainScreen.getMainMenu()._doLogout();
		} else {
		// There's no log out method available -> quit
			sendSyncMessage("quit", {});
		}
	}
});

addMessageListener("activateTab", function(obj) { 
	with (content.wrappedJSObject) { 
		//Tine.Tinebase.appMgr.activate(Tine.Tinebase.appMgr.getAll().map[obj.json.app]);
		Tine.Tinebase.appMgr.activate(Tine.Tinebase.appMgr.get(obj.json.app));
	}
});

addMessageListener("simulateButton", function(obj) { 
	
	function easySource(obj) {
		return obj.toSource().slice(1,-1)
	}

	var remoteAction = function remoteAction(app, fields = {}) {	
		// -- possible calls
		//remoteAction('Addressbook');	
		//remoteAction('Addressbook', {'n_family': 'zzzzzzzz', email: 'asdf@qwertz.com', bday: '1970-05-01'});
		//remoteAction('Felamimail');
		//remoteAction('Felamimail', {'subject': 'zzzzzzzz', to: 'asdf@qwertz.com', signature: 'Mit freundlichen Grüßen', body: 'Sehr geehrte Damen und Herren,'});
		//remoteAction('Tasks');
		// -- Parameter due doesn't work within tasks...
		//remoteAction('Tasks', {summary: 'test', status: "IN-PROCESS", priority: "URGENT", 'due': "2013-05-30 12:00:00"});
		//remoteAction('Calendar');
		//remoteAction('Calendar', {summary: 'test', dtstart: "2013-05-30 12:00:00", dtend: "2013-05-30 14:00:00", "is_all_day_event": false, originator_tz: "Europe/Berlin"});

		with (Tine.Tinebase.appMgr.get(app)) {
			var ms = getMainScreen(), cp = ms.getCenterPanel(),
			model = cp.recordClass.getMeta('modelName');
			
			var defaults = {};
			if (typeof Tine[app].Model[model].getDefaultData == 'function') {
				defaults = Tine[app].Model[model].getDefaultData();
			}

			if (app == 'Calendar') {
				/*
				 * Although Calendar has the most easiest call for opening a
				 * new Window with predefined values, it still differs very
				 * much from the other apps - cp.onEditInNewWindow exists for
				 * all apps in Tinebase/widgets/grid/GridPanel.js but you can
				 * not fill in defaults as easy. 
				 */
				cp.onEditInNewWindow('add', null, null, fields);
				return true;
			}
			else if (app == 'Felamimail') {
				// set given fields
				for (var i in fields) { 
					defaults[i] = fields[i]; 
				}
				// create body + signature
				var signature = (fields.signature) ? '<br><br><span id=\"felamimail-body-signature\">-- <br>' + fields.signature + '</span>' : Tine.Felamimail.getSignature();
				defaults.body = (defaults.body) ? defaults.body + signature : signature;
				// prevent listener 'load' to do things again
				fields = {};
			}
			
			var record = new Tine[app].Model[model](defaults);
			var dlgClass = cp.editDialogClass || cp.recordClass.getMeta('modelName')+'EditDialog';
			var overloadConfig = {
				plugins: null, 
				fixedFields: null, 
				record: record,
				copyRecord: false, 
				listeners: {
					scope: cp, 
					/* 
					 * Due to a hack for IE compatibility in getCenterPanel: function (config)
					 * (Tinebase/ux/WindowFactory.js) Tine's openWindow only allows ONE single
					 * listener. Therefore 'update' will be called from within and after the 
					 * first listener ('load'). 
					 *
					 * 'update': cp.onUpdateRecord,
					 */
					'load': function onloadpurse(editdlg) {
						for (i in fields) {
							editdlg.record.set(i, fields[i]);
						}

						// avoiding SINGLE listeners hack
						editdlg.events['load'].clearListeners();
						editdlg.addListener('update', cp.onUpdateRecord, cp);
					}, 
				}
			};
			Tine[app][dlgClass].openWindow(Ext.copyTo(cp.editDialogConfig || {}, overloadConfig, 'record,listeners,fixedFields,copyRecord,plugins'));
		}
	}; 
		
	/*
	 * Very dirty hack to use existing objects (wrappedJSObject does NOT 
	 * expose objects - only strings etc.)
	 * 
	 * Use a sandbox within scope of contentWindow. 
	 * 
	 * Create a function and fire it. Pass the whole object as string but
	 * remove (slice) brackets from toSource before...
	 */
	
	var sBox = Components.utils.Sandbox(content, { sandboxPrototype: content, wantXrays: false, sandboxName: 'purse-action'});
	Components.utils.evalInSandbox(
		easySource(remoteAction) + "\n" +
		"remoteAction('" + obj.json.app + "'" + ((obj.json.fields != false) ? ", " + easySource(obj.json.fields) : "") + ");"
	, sBox);
});


/*
 * EVENTS
 */

addEventListener("DOMContentLoaded", function() {
	// about:blank means quit the app || empty page can be failure of login
	if(content.document.body.innerHTML == '') {
		if (content.document.location == 'about:blank') {
			debug("Quit...\n");
			sendSyncMessage("quit", {});
			return true;
		} else {
			debug("Adjust configuration...\n");
			sendSyncMessage("configure", {'dialog': content.document.location.href});
			return true;
		}
	}
	
	/*
	 *  style tine 2.0
	 */
	
	// hide upper right menu
	var style = content.document.createElement('STYLE');
	style.type = 'text/css';
	style.innerHTML = '.tine-mainscreen-mainmenu table { margin-top: -30px;  }'; 
	content.document.getElementsByTagName('HEAD')[0].appendChild(style);
	
	// DOM ready?
	var menu_count = 0;

	var MutationObserver = content.MutationObserver || content.MozMutationObserver;
	var observer = new MutationObserver(function(mutations) { 
		mutations.forEach(function(mutation) {
			/*
			 * extjs will load elements into DOM when needed. Therefor in the beginning
			 * only the login gauge is loaded (class=tine-viewport-waitcycle)
			 * 
			 * Tine 2.0 is loaded into a second div. The screen itself is divided into
			 * four parts: one hidden div, two header rows and one body. 
			 */
			
			var mainPanel = content.document.getElementById('tine-viewport-maincardpanel');
			if (mainPanel != null && mainPanel.children.length > 1) {

				// existence of logout button == framework is loaded
				if (loggedIn == false && mutation.addedNodes.length && typeof mainPanel.getElementsByClassName('tine-mainscreen-mainmenu')[0] != undefined) {
					sendSyncMessage("login_success", {});
					loggedIn = true;
					content.wrappedJSObject.Tine.Tinebase.MainScreen.getMainMenu().action_logout.disable();
					/*
					 *  if observer is stopped menus and links can't be manipulated - Performance?!
					 */
					//observer.disconnect();
				}
			}
			
			/*
			 * Menus are added 'on the fly'
			 */
			if (mutation.addedNodes.length > 0 && mutation.addedNodes[0].tagName == 'DIV' && mutation.addedNodes[0].className.substr(0, 6) == 'x-menu') {
				/*
				 * Manipulate MainMenu - TODO: remove webapp entries and logout
				 */
				var xmenu = content.document.getElementById(mutation.addedNodes[0].id);
			}	
			
			/*
			 * If links "<a>" are loaded connect them to sandbox before new window opens "target=_blank"
			 */
			if (mutation.addedNodes.length > 0 && mutation.type === 'childList') {
				var aNodes = null;
				for (addedNode of mutation.addedNodes) {
					try {
						for (aNode of addedNode.querySelectorAll('a')) {
							if (aNode.href.substr(0, content.document.location.href.length) != content.document.location.href) {
								// this link's href points to outside of Tine
								aNode.target = "";
							}
						}
					} 
					catch (e) {}
				}
			}
		});   
	});
	observer.observe(content.document.querySelector('body'), { childList: true, subtree: true });
	
	/*
	 * Handle objects which are ready after DOM is loaded 
	 * (basically only Ext but no Tine elements)
	 */
	with (content.wrappedJSObject) {
		// replace notifications by mozilla's
		Ext.ux.Notification.show = function(title, text) {
			sendSyncMessage("notify", {'title':title,'text':text});
		}
	}
	
}, true);

addEventListener('contextmenu', function(e) {
	switch (e.target.nodeName) {
		case 'TEXTAREA':
		case 'INPUT':
			e.preventDefault();
			debug(e.target.nodeName);
	}
}, false);
