const Cc = Components.classes;
const Ci = Components.interfaces;
 
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
Components.utils.import("resource://gre/modules/Services.jsm");
 
const CHROME_URI = "chrome://tinepurse/content/";

/*
 * Utility functions
 */
 
// Command Line Handler
function CommandLineHandler() {
};
 
CommandLineHandler.prototype = {
  classDescription: "tinepurse",
  classID: Components.ID('{ea707eff-9965-4b8a-80d4-8f05d2d9dd76}'),
  contractID: "@mozilla.org/commandlinehandler/general-startup;1?type=tinepurse",
  _xpcom_categories: [{
    category: "command-line-handler",
    entry: "m-tinepurse"
  }],
 
  QueryInterface: XPCOMUtils.generateQI([
    Ci.nsICommandLineHandler
  ]),
 
  /* nsICommandLineHandler */
  handle : function clh_handle(cmdLine)
  {  
	// simply pass whole nsICmdLine-Object
	var observerService = Components.classes["@mozilla.org/observer-service;1"]
			.getService(Components.interfaces.nsIObserverService);
		observerService.notifyObservers(cmdLine, "purse-instance-cli", null);
  },
 
  // Specifically, flag descriptions should start at
  // character 24, and lines should be wrapped at
  // 72 characters with embedded newlines,
  // and finally, the string should end with a newline
  helpInfo : "\nTine 2.0 specific options\n\n"+
             "Usage: tine2.0 [APP] [-compose|CONTENT]\n\n" +
             "Running tine2.0 without any options brings main window to front. If [APP] is \n"+
             "specified but no further argument is given the choosen app panel gets activated.\n" +
             "To open new editor window of [APP] a second argument is madatory. Specifying\n"+
             "[-compose] will open an empty window otherwise default content can be provided\n"+
             "as described below whereas [CONTENT] differs from app to app. \n\n"+
             "  [APP]              [CONTENT]\n" +
             "  -mail or           Content is expected to be  a rfc 2368 compatible URL, e.g.\n" +
             "  -felamimail        'mailto://user@example.com?subject=Test'.\n\n" +
             "  -contacts or       Provide path to a vCard file (vcf)\n" +
             "  -addressbook       \n\n" +
             "  -calendar          Provide path to a iCal file (ics)\n\n" +
             "  -tasks             Provide path to a iCal file (ics)\n\n" +
             "  SPECIAL USAGE\n"+
             "  -logout            Log current user out and close Purse.\n"+
             "  \n"
};

var NSGetFactory = XPCOMUtils.generateNSGetFactory([CommandLineHandler]);
